/*
 * RIPE version marten@ripe.net
 * many changes & networkupdate by david@ripe.net
 * cosmetics by steven@dante.org.uk --	gcc stopped complaining mostly,
 *					code is still messy, though.
 * heavily modified by davidk@ISI.EDU for client support for
 * (NIC handle) references and networkupdate -M
 *
 * 1.2  9705/02
 * "-v" option added; ambrose@ripe.net
 *
 * 1.2.1  9705/15     steven@dante.org.uk (Steven Bakker)
 * Fixed core dump bug: "whois -t xyz", "whois -v abc" dumped core.
 * Argument handling was screwy;
 *
 *
 * 1.15 94/09/07
 *
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * sendmail codes
 */

int optM=0;

#ifndef DEFAULT_SERVER
#define DEFAULT_SERVER 1
#endif

char *whois_servers[] = {
  "internic", "whois.internic.net",
  "radb",     "whois.ra.net",
  "mci",      "whois.mci.net",
  "6bone",    "whois.6bone.net",
  "ripe",     "whois.ripe.net",
  "apnic",    "whois.apnic.net",
  "siemens6",  "whois.ipv6.siemens.co.uk",
  (char *)0, (char *)0
};


#ifdef NETWORKUPDATE
#include <sysexits.h>

#define WHOIS_TIMEOUT 300

void alarmhandler(sig, code, scp, addr)
int sig, code;
struct sigcontext *scp;
char *addr;
{
  exit(EX_TEMPFAIL);
}

#else
#define EX_TEMPFAIL -1
#endif

#if defined(sun) && defined(solaris)
#define SYSV
#endif

#ifndef lint
char copyright[] =
"@(#)Copyright (c) 1980 Regents of the University of California.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef RIPE
#ifndef lint
char sccsid[] = "@(#)whois.c	5.11 (Berkeley) 3/2/91";
#endif /* not lint */
#endif /* not RIPE */

#ifdef RIPE
#ifndef lint
char sccsid[] =
    "@(#)whois.c 5.11 (Berkeley) 3/2/91 - RIPE 1.15 94/09/07 marten@ripe.net";
#endif /* not lint */
#endif /* RIPE */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#ifdef INET6
#include <netinet/in6.h>
#endif
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <pwd.h>
#include <signal.h>

#if defined(SYSV)
#include	<crypt.h>
#endif /* SYSV */

#ifdef __STDC__
extern int	getopt(int argc, char * const *argv, const char *optstring);
extern int	kill(pid_t pid, int sig);
extern FILE	*fdopen(int fildes, const char *type); 
extern int	gethostname(char *name, int namelen);
extern char     *strdup(const char *);
#else /* !__STDC__ */
extern int	gethostname();
#endif /* __STDC__ */

#if defined(SYSV) || defined(__STDC__)

#define		index(s,c)		strchr((const char*)(s),(int)(c))
#define		rindex(s,c)		strrchr((const char*)(s),(int)(c))
#define		bzero(s,n)		memset((void*)s,0,(size_t)n)

#ifdef HASMEMMOVE
# define	bcopy(s,d,n)	memmove((void*)(d),(void*)(s),(size_t)(n))
#else
# define	bcopy(s,d,n)	memcpy((void*)(d),(void*)(s),(size_t)(n))
#endif /* HASMEMMOVE */

#endif /* SYSV || __STDC__ */

/*

# the following defines can be used but are not fully functional anymore...
#
# CLEVER- Use a educated guess of the whereabouts of the nearest server
#	  This is done by taking the top-level domain of the current
#	  machine, and looking for a CNAME record for a server with name
#	  <top-level-domain>-whois.ripe.net
#	  If this machine does not exsist or the current machine's top-level
#	  domain could not be found,it will fall back to whois.ripe.net
#	  the default for this RIPE version of whois
#	  The CLEVER option implies the RIPE option.

# TOPDOMAIN=\"<top-level-domain>\"
#	- This option will fix the default host to be
#	  <top-level-domain>-whois.ripe.net, which may point to a secondary
#	  server inside your top-level domain. If there is no such secondary
#	  server, it will point to whois.ripe.net, the default. This option
#	  overrules the CLEVER option.
#	  The TOPDOMAIN option implies the RIPE option.

*/

#if defined(TOPDOMAIN) || defined(CLEVER)
#ifndef RIPE
#define RIPE
#endif /* !RIPE */
#endif /* TOPDOMAIN || CLEVER */

#ifdef RIPE
#include <sys/param.h>
#endif

void usage()
{
#ifdef RIPE
#ifdef NETWORKUPDATE
  (void)fprintf(stderr, "\nUsage: networkupdate [-h hostname] [-p port] [-lM]");
#else
  (void)fprintf(stderr, "\nUsage: whois [-aFLmMrSvl] [-h hostname] [-s sources] [-T types] [-i attr] keys\n");
  (void)fprintf(stderr, "       whois -t type");
#endif
#else
  (void)fprintf(stderr, "\nUsage: whois [-h hostname] [-p port] [-l] name ...");
#endif
  (void)fprintf(stderr, "\n\nWhere:\n\n");
#ifdef RIPE
#ifndef NETWORKUPDATE
  (void)fprintf(stderr, "-a                         search all databases\n");
  (void)fprintf(stderr, "-F                         fast raw output\n");
#endif
#endif
  (void)fprintf(stderr, "-h hostname                search alternate server\n");
  (void)fprintf(stderr, "-l                         list common whois servers\n");
#ifdef RIPE
#ifndef NETWORKUPDATE
  (void)fprintf(stderr, "-i [attr][[,attr] ... ]    do an inverse lookup for specified attributes\n");
  (void)fprintf(stderr, "-L                         find all Less specific matches\n");
  (void)fprintf(stderr, "-m                         find first level more specific matches\n");
  (void)fprintf(stderr, "-M                         find all More specific matches\n");
#endif
#endif
  (void)fprintf(stderr, "-p port                    port to connect to\n");
#ifdef NETWORKUPDATE
  (void)fprintf(stderr, "-M                         treat input as a mail\n");
#endif
#ifdef RIPE
#ifndef NETWORKUPDATE
  (void)fprintf(stderr, "-r                         turn off recursive lookups\n");
  (void)fprintf(stderr, "-R                         turn off external recursive lookups\n");
  (void)fprintf(stderr, "-s source[[,source] ... ]  search databases with source 'source'\n");
  (void)fprintf(stderr, "-S                         tell server to leave out 'syntactic sugar'\n");
  (void)fprintf(stderr, "-t type                    requests template for object of type 'type'\n");
  (void)fprintf(stderr, "-T type[[,type] ... ]      only look for objects of type 'type'\n");
  (void)fprintf(stderr, "-v type                    requests verbose template for object of type 'type'\n\n");
  (void)fprintf(stderr, "Please note that most of these flags are NOT understood by\n");
  (void)fprintf(stderr, "non RIPE whois servers\n");
#endif
#endif
  (void)fprintf(stderr, "\n");

  exit(1);
}

void list_whois()
{
 int i;
  (void)fprintf(stdout, "\nInternally configured whois servers:\n\n");
  for (i=0;whois_servers[i]!=NULL;i+=2) {
      (void)fprintf(stdout, "%s - %s\n",whois_servers[i],whois_servers[i+1]);
  }
  (void)fprintf(stdout, "\n");
  exit(EX_TEMPFAIL);
}


int s;

void closesocket(s, child, exitcode) 
int s, child, exitcode;
{
  /* printf("close connection child=%i\n", child);  */

  close(s);

#ifdef NETWORKUPDATE
  if (child==0) {
     kill(getppid(), SIGTERM);
  }
  exit(exitcode);
#endif

}

void termhandlerparent(sig, code, scp, addr)
int sig, code;
struct sigcontext *scp;
char *addr;
{
  if (optM) {
     closesocket(s,1,EX_TEMPFAIL);
  }
  else {
     closesocket(s,1,0);
  }
}

void termhandlerchild(sig, code, scp, addr)
int sig, code;
struct sigcontext *scp;
char *addr;
{
  closesocket(s,0,0);
}   


#ifdef RIPE
#if defined(__STDC__) || defined(SYSV)
#define occurs(str,pat)		((int) strstr((str),(pat)))
#else /* !__STDC__ && !SYSV */
int occurs(str, pat)
     char *str, *pat;
{
  register char *point = str;
  
  while ((point=index(point, *pat)))
    {
      if (strncmp(point, pat, strlen(pat)) == 0)
	return(1);
      point++;
    }
  return(0);
}
#endif
#endif

int main(argc, argv)
     int argc;
     char **argv;
{
  extern char *optarg;
  extern int optind;
  FILE *sfi;
  FILE *sfo;
  int ch,counter;
#ifdef INET6
  struct sockaddr_in6 sin;
#else
  struct sockaddr_in sin;
#endif
  struct hostent *hp;
  struct servent *sp;
  char *host, *whoishost;
  int optp=0, optport=0, exitcode=0,optl=0;
  int child=0;
  char *progname;
#ifdef RIPE
  int verb=0, opthost=0;
#ifndef NETWORKUPDATE
  /* normal whois client */
  char *string;
  int alldatabases=0;
  int optsource=0, optrecur=0, noendemptylines=0, optR=0, optfast=0, opttempl=0, opttemplverb=0, optk=0;
  int optobjtype=0, optsugar=0, optinverselookup=0, optgetupdates=0;
  int optL=0, optm=0;
  char	*source=NULL, *templ=NULL, *objtype=NULL,
	*inverselookup=NULL, *getupdates=NULL;
#else /* NETWORKUPDATE */
  /* networkupdate client */
  int prev;
  char domainname[64]; /* that's what sys/param.h says */
  struct passwd *passwdentry;
  
#endif
#ifdef CLEVER
  int  myerror;
  char *mytoplevel;
  char *myhost;
#endif
#endif
  
#ifdef TOPDOMAIN
  host = strcat(TOPDOMAIN, "-whois.ripe.net");
#else
  host = whois_servers[DEFAULT_SERVER];   /* default to first whois server */
#endif
  
  progname = argv[0];

#ifdef RIPE
#ifdef NETWORKUPDATE
    while ((ch = getopt(argc, argv, "h:p:lM")) != EOF)
#else
  /* -0 is a special option that cuts off the last two empty lines */
  while ((ch = getopt(argc, argv, "aFg:h:i:kLlmMp:rRs:St:T:v:0")) != EOF)
#endif
#else
    while ((ch = getopt(argc, argv, "lh:p:")) != EOF)
#endif
      switch((char)ch) {
      case 'h':
	host = optarg;
	opthost = 1;
	break;
      case 'p':
        optport=htons((unsigned short int)atoi(optarg));
        optp =1;
        break;
      case 'l':
        list_whois();
       optl=1;
       break;	
#ifdef RIPE
#ifdef NETWORKUPDATE
      case 'M':
	optM=1;
	break;
#else
      case '0':
        noendemptylines=1;
        break;
      case 'a':
	alldatabases=1;
	break;
      case 'F':
	optfast = 1;
	break;
      case 'g':
        getupdates=optarg;
	optgetupdates=1;
	break;
      case 'i':
        inverselookup=optarg;
	optinverselookup = 1;
	break;
      case 'k':
	optk = 1;
	break;
      case 'L':
	if (optM || optm) {
          fprintf(stderr, "Only one of -L, -m or -M allowed\n\n");
          usage();
        }
	optL=1;
	break;
      case 'm':
	if (optM || optL) {
	  fprintf(stderr, "Only one of -L, -m or -M allowed\n\n");
          usage();
	}
	optm=1;
	break;
      case 'M':
	if (optL || optm) {
	  fprintf(stderr, "Only one of -L, -m or -M allowed\n\n");
	  usage();
	}
	optM=1;
	break;
      
      case 's':
	source = optarg;
	optsource=1;
	break;
      case 'S':
	optsugar=1;
	break;
      case 'r':
	optrecur=1;
	break;
      case 'R':
	optR=1;
	break;
      case 't':
	 templ=optarg;
	 opttempl=1;
	 break;
      case 'T':
	objtype=optarg;
	optobjtype=1;
	break;
      case 'v':
	 templ=optarg;
	 opttemplverb=1;
	 break;
      
#endif	
#endif
      case '?':
      default:
	usage();
      }
  argc -= optind;
  argv += optind;

if ((argc<=0) && (optl)) {
   exit(EX_TEMPFAIL);
}

#ifdef RIPE
#ifdef NETWORKUPDATE
  if (argc>0)
    usage();
#else
  if ((argc<=0) && 
      (((!opttempl) && (!opttemplverb) && (!optgetupdates)) || 
       ((opttempl && optgetupdates) ||
        (opttemplverb && optgetupdates) ||
        (opttempl && opttemplverb)))) {
     usage();
  }
  if ((argc>0) && ((opttempl) || (opttemplverb) || (optgetupdates))) {
     usage();   
  } 
#endif
#else
  if (argc<=0)
    usage();
#endif

  if (!opthost) {
    
#ifdef CLEVER
    whoishost=(char *)calloc(MAXHOSTNAMELEN, sizeof(char));
    myhost =(char *)calloc(MAXHOSTNAMELEN, sizeof(char));
    myerror = gethostname(myhost, MAXHOSTNAMELEN);
    if (myerror >= 0) {
      if (occurs(myhost, ".")) {
	mytoplevel = rindex(myhost,'.');
	mytoplevel++;
	(void) sprintf(whoishost, "%s-whois.ripe.net", mytoplevel);
	if (verb) fprintf(stderr, "Clever guess: %s\n", whoishost);
      }
    }
#ifdef INET6
    hp = gethostbyname2(whoishost, AF_INET6);
#else
    hp = gethostbyname(whoishost);
#endif
    if ((hp == NULL) && (verb)) 
      fprintf(stderr,"No such host: %s\n", whoishost);

    if (hp==NULL) {
#endif
    
      whoishost=whois_servers[DEFAULT_SERVER];

      if (verb) fprintf(stderr, "Default host: %s\n\n", whoishost);
#ifdef INET6
      hp = gethostbyname2(whoishost, AF_INET6);
#else
      hp = gethostbyname(whoishost);
#endif
      
      if (hp == NULL) {
	fprintf(stderr,"No such host: %s\n", whoishost);
	if (verb) fprintf(stderr, "Now I give up ...\n");
	perror("Unknown host");
	exit(EX_TEMPFAIL);
      }

#ifdef CLEVER
    }
#endif
  }
  else {
    if (verb) fprintf(stderr, "Trying: %s\n\n", host);
    /* first see if this is one of the built in aliases */
    for (counter=0;whois_servers[counter]!=NULL;counter+=2) {
       if (!strcmp(whois_servers[counter],host)) {
          host=whois_servers[counter+1];
          break;
       }
    }
#ifdef INET6
    hp = gethostbyname2(host, AF_INET6);
#else
    hp = gethostbyname(host);
#endif
    if (hp == NULL) {
      (void)fprintf(stderr, "whois: %s: ", host);
      perror("Unknown host");
      exit(EX_TEMPFAIL);
    }
  }
  
  host=strdup(hp->h_name);
  s = socket(hp->h_addrtype, SOCK_STREAM, 0);
  if (s < 0) {
    perror("whois: socket");
    exit(EX_TEMPFAIL);
  }
  bzero((void *)&sin, sizeof (sin));
#ifdef INET6
  sin.sin6_family = hp->h_addrtype;
#else
  sin.sin_family = hp->h_addrtype;
#endif
  if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
    perror("whois: bind");
    exit(EX_TEMPFAIL);
  }
#ifdef INET6
  bcopy(hp->h_addr, (char *)&sin.sin6_addr, hp->h_length);
#else
  bcopy(hp->h_addr, (char *)&sin.sin_addr, hp->h_length);
#endif
  
  if (optp) {
#ifdef INET6
     sin.sin6_port=optport;
#else
     sin.sin_port=optport;
#endif
  }
  else {
     
     sp=getservbyname("whois", "tcp");
  
     if (sp == NULL) {
        (void)fprintf(stderr, "whois: whois/tcp: unknown service\n");
        exit(EX_TEMPFAIL);
     }
  
#ifdef INET6
     sin.sin6_port = sp->s_port;
#else
     sin.sin_port = sp->s_port;
#endif

  }

#ifdef INET6
  /* printf("%i\n", sin.sin6_port); */
#else
  /* printf("%i\n", sin.sin_port); */
#endif

  if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
    perror("whois: connect");
    exit(EX_TEMPFAIL);
  }

  signal(SIGTERM, termhandlerparent);  

#ifdef RIPE
#ifdef NETWORKUPDATE

  if ((optM) || ((child=fork())==0)) {
     
     int  size=0;
     int  buffersize=16*1024;
     char *buffer=(char *)malloc(buffersize*sizeof(char));

     if (optM) {
        
        char *buffer_ptr=buffer;

        while ((ch = getc(stdin)) != EOF) {

           *buffer_ptr=(char)ch;
           ++buffer_ptr;
           ++size;

           if (size+16>buffersize) {
              alarm(WHOIS_TIMEOUT);  
              buffersize*=2;
              buffer=(char *)realloc(buffer, buffersize*sizeof(char));
              buffer_ptr=buffer+(size*sizeof(char));
           }

        }

        if ('\n'!=*(buffer_ptr-1)) {
           *buffer_ptr='\n';
           ++buffer_ptr;
           ++size;
        }
        *buffer_ptr='\0';


     }
     
     signal(SIGALRM, alarmhandler);  

     if (gethostname(domainname, sizeof(domainname))) {
        fprintf(stderr, "error when doing gethostname()");
        exit(EX_TEMPFAIL);
     }

     passwdentry=getpwuid(getuid());

     sfo=fdopen(s, "w");
     if (sfo == NULL) {
       perror("whois: fdopen");
       (void)close(s);
       exit(EX_TEMPFAIL);
     }

     alarm(WHOIS_TIMEOUT);
     if (optM) {
        fprintf(sfo, "-V nc3.0 -U %s %s -M\n%i\n", passwdentry->pw_name, domainname, size);
     }
     else {
        fprintf(sfo, "-V nc3.0 -U %s %s\n", passwdentry->pw_name, domainname);
     }
     fputs(buffer, sfo);
     fflush(sfo);  

     if (!optM) {
        
        signal(SIGTERM, termhandlerchild);  

        prev='\0';

        while ((ch=getchar()) != EOF) {
        
           fputc(ch, sfo);
        
           if (ch=='\n') fflush(sfo);
           if (feof(sfo)) closesocket(s, child, 0);
           if ((ch=='.') && (prev=='\n')) closesocket(s, child, 0);
           if ((!isspace(ch)) || ((!isspace(prev)) && (ch=='\n'))) prev=ch;
        }

        closesocket(s, child, 0);

     }

  }

  sfi=fdopen(s, "r");
  if (sfi == NULL) {
     perror("whois: fdopen");
     (void)close(s);
     exit(EX_TEMPFAIL);
  }

  if (optM) {

     alarm(WHOIS_TIMEOUT);
     if (((ch = getc(sfi)) == EOF) || (ch!='D')) {
        putchar(ch);
        exitcode=EX_TEMPFAIL;
     }
     alarm(WHOIS_TIMEOUT);
     if ((EOF!=ch) && (((ch = getc(sfi)) == EOF) || (ch!='O'))) {
        putchar(ch);
        exitcode=EX_TEMPFAIL;
     }
     alarm(WHOIS_TIMEOUT);
     if ((EOF!=ch) && (((ch = getc(sfi)) == EOF) || (ch!='N'))) {
        putchar(ch);
        exitcode=EX_TEMPFAIL;
     }
     alarm(WHOIS_TIMEOUT);
     if ((EOF!=ch) && (((ch = getc(sfi)) == EOF) || (ch!='E'))) {
        putchar(ch);
        exitcode=EX_TEMPFAIL;
     }  
     alarm(WHOIS_TIMEOUT);
     if ((EOF!=ch) && (((ch = getc(sfi)) == EOF) || (ch!='\n'))) {
        putchar(ch);
        exitcode=EX_TEMPFAIL;
     }
     
     if (0==exitcode) {
        exit(0);
     }

  }
  else {

     while ((ch=fgetc(sfi)) != EOF) {
        putchar(ch);
     }

     closesocket(s, child, 1);

  }


#else
  
  sfi = fdopen(s, "r");
  sfo = fdopen(s, "w");
  if (sfi == NULL || sfo == NULL) {
    perror("whois: fdopen");
    (void)close(s);
    exit(EX_TEMPFAIL);
  }

  if (alldatabases)
    (void)fprintf(sfo, "-a ");
  if (optfast)
    (void)fprintf(sfo, "-F ");
  if (optgetupdates)
    (void)fprintf(sfo, "-g %s ", getupdates);  
  if (optinverselookup)
    (void)fprintf(sfo, "-i %s ", inverselookup);
  if (optk)
    (void)fprintf(sfo, "-k ");
  if (optL)
    (void)fprintf(sfo, "-L ");
  if (optm)
    (void)fprintf(sfo, "-m ");
  if (optM)
    (void)fprintf(sfo, "-M ");
  if (optrecur)
    (void)fprintf(sfo, "-r ");
  if (optR)
    (void)fprintf(sfo, "-R ");
  if (optsource)
    (void)fprintf(sfo, "-s %s ", source);
  if (optsugar)
    (void)fprintf(sfo, "-S ");
  if (opttempl)
    (void)fprintf(sfo, "-t %s ", templ);
  if (optobjtype)
    (void)fprintf(sfo, "-T %s ", objtype);
  if (opttemplverb)
    (void)fprintf(sfo, "-v %s ", templ);

  /* we can only send the -V when we are sure that we are dealing with 
     a RIPE whois server :-( */
  
  whoishost=(char *)calloc(strlen(host)+1, sizeof(char));
  strcpy(whoishost, host);
  for (string=whoishost;(*string=(char)tolower(*string));string++);
  
  if (strstr(whoishost, "ripe.net") ||
      strstr(whoishost, "apnic.net") ||
      strstr(whoishost, "mci.net") ||      
      strstr(whoishost, "isi.edu") ||
      strstr(whoishost, "6bone.net") ||
      strstr(whoishost, "garr.it") ||
      strstr(whoishost, "ans.net") ||
      alldatabases || optfast || optgetupdates || optinverselookup ||
      optL || optm || optM || optrecur || optR || optsugar || optsource ||
      opttempl || opttemplverb || optobjtype) {
     /* a space after -V is the new syntax */
     if (strstr(whoishost, "ripe.net") ||
         strstr(whoishost, "isi.edu") ||
         strstr(whoishost, "6bone.net")) {
        (void)fprintf(sfo, "-V wc3.0 ");
     }
     else {
        (void)fprintf(sfo, "-Vwc3.0 "); 
     }
  }

  while (argc-->1) {
     (void)fputs(*argv++, sfo); 
     if ((1!=argc) || (*argv)) {
        (void)fputs(" ", sfo);
     }
  }
  if (*argv) { 
     (void)fputs(*argv, sfo);
  } 
  (void)fputs("\n", sfo);
  (void)fflush(sfo);

  if ((optk) && ((child=fork())==0)) {
     
     int eof=1;

     while ((ch = getc(stdin))!= EOF) {

        if (fputc(ch, sfo)==EOF) {
           break;
        }

        if (!isspace(ch)) {
           eof=0;
        }
 
        if ('\n'==ch) {
           if (eof) {
              break;              
           }
           fflush(sfo);  
           eof=1;
        }

     }
     
     fflush(sfo);     
     closesocket(s, child, 0);

     exit(0);

  }
#endif

#ifndef NETWORKUPDATE 
   if (optR) { 
#endif
      while ((ch = getc(sfi)) != EOF) {
         putchar(ch);
      }

      closesocket(s, 1, exitcode);

#ifndef NETWORKUPDATE
  }
  else {

      int eol=2;
      char referto[]="% referto:";
      char *referto_ptr=&referto[0];
      char resultstring[8192];
      char *result=&resultstring[0];
      *result='\0';

      while ((ch = getc(sfi)) != EOF) {

         if ('\r'==ch) {
            putchar(ch);
            continue;
         }
         if ('\n'==ch) {
            referto_ptr=&referto[0];
            if (!eol) {
               putchar(ch);
            }
            eol++;
         }
         else {
            if (eol) {
               if (ch==*referto_ptr) {

                  /* for security checkings,
                     we don't want to execute other programs by using:
                     ; or | or || or && 
                     in the refer string */

                  int slash=0;
                  int and=0;

                  ++referto_ptr;

                  if (!*referto_ptr) {
                     if (result!=&resultstring[0]) {
                        *result=';';
                        result++;
                     }

                     /* skip until whois */

                     while (((ch = getc(sfi)) != EOF) && ('s'!=ch)) {}
                     strcat(result, progname);
                     result+=strlen(progname);

                     /* special don't show empty lines option */

                     strcat(result, " -0");
                     result+=3;

                     /* copy command */

                     while (((ch = getc(sfi)) != EOF) && ('\n'!=ch)) {
                        
                        if ('\\'==ch) {
                           *result=ch;
                           result++;
                           
                           and=0;
                           slash++;
                           continue;
                        }

                        if (slash) {
                           *result=ch;
                           result++;

                           slash=0;
                           continue;
                        }

                        if (('&'==ch) || ('|'==ch) || (';'==ch)) {
                           
                           if ('&'==ch) {
                              and++;
                              slash=0;
                           }

                           if ((and>1) || ('|'==ch) || (';'==ch)) {
                              printf("stopped\nfound insecure reference:\n\n");
                              if (referto_ptr!=referto) {
                                 fwrite(&referto[0], 1, (referto_ptr-referto), stdout);
                              }
                              putchar(ch);
                              while (((ch = getc(sfi)) != EOF) && ('\n'!=ch)) { 
                                 putchar(ch);
                              }
                              putchar('\n');
                              exit(1);
                           }

                           *result=ch;
                           result++;

                        }

                        and=0;
                        *result=ch;
                        result++;

                     }
                     *result='\n';
                     *(result+1)='\0';
                     ch=getc(sfi);
                     referto_ptr=&referto[0];
                  }
 
               }
               else {
                  if (eol>1) {
                     putchar('\n');
                  }
                  if (referto_ptr!=referto) {
                     fwrite(&referto[0], 1, (referto_ptr-referto), stdout);
                  }
                  putchar(ch);
                  eol=0;
               }
            }
            else {
               putchar(ch);
            }
         
         }

      }
      
      close(s);
      
      if (!noendemptylines) {
         
         if (result!=&resultstring[0]) {
            fflush(stdout);
            system(resultstring); 
            /* printf("*%s*\n", resultstring); */
         }
         
         putchar('\n');
         putchar('\n');

      }

  }
#endif
#endif

  exit(exitcode);

}
