.TH WHOIS 1 "94/09/07"
.\" RIPE version marten@ripe.net 1.10 94/09/07
.SH NAME
whois \- TCP/IP Internet directory service, RIPE version
.SH SYNOPSIS
.B whois
[
.B \-aFlrR
]
[
.B \-h
.I host
]
[
.B \-p
.I port
]
[
.B \-i
.I attributes
]
[
.B \-s
.I sources
]
[
.B \-T
.I types
]
[
.B \-L | \-m | \-M
] SearchKey

.B whois \-t type

.B whois \-v type

.SH DESCRIPTION
.B whois
searches for an object in the RIPE Network Management database.
The key can be either a name (such as "Karrenberg"),a nic-handle
(such as "DK58"),
a network number ("192.87.45.0/24") or a domain name ("ripe.net").

This version of the whois client works with a version of the RIPE
database whois server that supports classless IP addresses. 
All IP network numbers are considered classless IP network numbers of
the form prefix/length, like 192.87.45.0/24 for a class C sized network
number and 128.86.0.0/16 for a class B sized network number. Any
length can be given. If no length is given, the server assumes a host
lookup (ie length 32).

By default, the server will return the first less specific network
number, which can be an exact match if available in the database.
.SH OPTIONS
.TP 8
.B \-a
This causes the server to include information from
non-RIPE whois databases in the reply. Currently these are the public
parts of the US NIC and NSFnet databases. Please note that the RIPE
NCC does not maintain these databases. The information is included for
for your convenience only.
.TP 8
.B \-F
fast output. Force the whois server to not reformat the output. This
can save time for large objects. The output of the RIPE whois server
will be in two letter short form. This option implies -r.
.TP 8
.B \-h host
Select alternate host to direct the query
.TP 8
.B \-p port
Connect to port 'port'
.TP 8
.B \-L
lookup all less specific networks. Has effect only when looking up IP
network numbers.
.TP 8
.B \-m
lookup first level more specific networks. Has effect only when
looking up IP network numbers.
.TP 8
.B \-M
lookup all more specific networks. Has effect only when looking up IP
network numbers.
.TP 8
.B \-r
non-recursive lookup. This will cause the server to not lookup
referenced objects.
.TP 8
.B \-R
non-recursive external lookups. This will cause the server not to send
references to external objects to the whois client.
.TP 8
.B \-i attributes
attributes is a comma separated list of attributes.
the whois server will return all objects that match the search keys
in one of these attributes.
.TP 8
.B \-l
list internal whois server alias list. Aliases can be used as an argument
for the '-h' option. 
.TP 8
.B \-s sources
sources is a comma separated list of database sources. 
The whois server will only search the databases that match the
specified sources.
.TP 8
.B \-t type
requests the server to send a template for an object with type "type".
.TP 8
.B \-T types
types is a comma separated list of object types.
requests the server to only send back objects that match one of the "types".
.TP 8
.B \-v type
requests the server to send a verbose template for an object with type "type".
.LP
.SH EXAMPLES
.IP
.B example% whois karrenberg
.IP
person:  Daniel Karrenberg
.br
address: RIPE Network Coordination Centre
.br
address: Kruislaan 409
.br
address: NL-1098 SJ Amsterdam
.br
address: Netherlands
.br
phone:   +31 20 5925065
.br
fax-no:  +31 20 5925155
.br
e-mail:  dfk@ripe.net
.br
nic-hdl: DK58
.br
changed: dfk@ripe.net 920407
.br
changed: ripe-dbm@ripe.net 920407
.br
source:  RIPE
.IP
.B example% whois -h whois.ripe.net -r 192.87.45.0/24
.IP
inetnum:     192.87.45.0
.br
netname:     RIPE-NCC
.br
descr:       RIPE Network Coordination Centre
.br
descr:       Amsterdam, Netherlands
.br
country:     NL
.br
admin-c:     Daniel Karrenberg
.br
tech-c:      Marten Terpstra
.br
connect:     RIPE NSF WCW
.br
aut-sys:     AS3333
.br
ias-int:     192.87.45.80  AS1104
.br
ias-int:     192.87.45.6   AS2122
.br
ias-int:     192.87.45.254 AS2600
.br
rev-srv:     ns.ripe.net
.br
rev-srv:     ns.eu.net
.br
notify:      ops@ripe.net
.br
changed:     tony@ripe.net 940110
.br
source:      RIPE
.LP
.SH RIPE VERSION	
This is the RIPE version of the whois client program.

The program is heavily modified by davidk@ISI.EDU for client support of
(NIC handle) references for RIPE servers.

For questions refer to <ncc@ripe.net>. For more information about the
RIPE database please also refer to <ncc@ripe.net>.
.LP
.SH BUGS
Most of the extra flags are ONLY supported by the RIPE whois server,
or copies of the same version of the software. Usage of these flags
may cause errors on other whois servers.
.\".SH SEE ALSO
.\"RFC 812:  NICNAME/WHOIS
